<template>
  <div id="sw-quickview-modal" data-cy="quickview-modal">

    <SfModal class="sw-modal" :visible="isModalOpen" :cross="false">

      <template #modal-bar>
        <div class="sw-quickview-close">
          <SfButton class="sf-button--pure sf-bar__icon" aria-label="close" type="button" @click="toggleModal()">
            <SfIcon icon="cross" size="20px"/>
          </SfButton>
        </div>
      </template>

      <div class="sw-quickview-content sw-gs-cms-product-page">
        <SfLoader :loading="isLoading">
          <div>
            <SwPluginSlot name="gs-quickview-content-before" :slotContext="cmsPage"/>

            <CmsPage v-if="cmsPage" :content="cmsPage.cmsPage"/>
          </div>
        </SfLoader>
      </div>

    </SfModal>
  </div>
</template>

<script lang="ts">
  import { SfButton, SfIcon, SfLoader, SfModal } from "@storefront-ui/vue";
  import { useUIState } from "@shopware-pwa/composables";
  import { watch, computed } from "@vue/composition-api";
  import CmsPage from '@/cms/CmsPage.vue';
  import { provide } from "vue-demi";
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue";

  import { useQuickView } from "../../logic/composables/useQuickView";
  import { useInteractions } from "../../logic/composables/useInteractions";
  import {useClearBodyScrollLock} from "../../logic/composables/useClearBodyScrollLock";

  export default {
    name: "SwGsQuickViewModal",
    components: {
      SfLoader,
      SfButton,
      SfIcon,
      SfModal,
      CmsPage,
      SwPluginSlot
    },

    setup() {
      const { quickViewCmsPage, isQuickViewLoading } = useQuickView();
      const { isOpen, switchState } = useUIState({ stateName: `GS_QUICKVIEW_MODAL_STATE` });
      const { publishInteraction } = useInteractions();

      useClearBodyScrollLock();

      const cmsPage = computed(() => quickViewCmsPage.value);
      const isLoading = computed(() => isQuickViewLoading.value);

      watch(isOpen, async () => {
        if (isOpen.value) return;

        publishInteraction({
          name: 'quickview.closed',
          payload: {
            productId: quickViewCmsPage?.value?.product?.id,
          }
        });
      });

      provide('cms-page', cmsPage);
      provide("use-guided-shopping-actions", false);
      provide("gs-product-page-type", computed(() => 'quickView'));

      return {
        toggleModal: switchState,
        isModalOpen: isOpen,
        isLoading,
        cmsPage,
      }
    },
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  #sw-quickview-modal {
    box-sizing: border-box;

    @include for-desktop {
      & > * {
        --modal-width: unset;
        --modal-content-padding: var(--spacer-xl) var(--spacer-base);
      }
      ::v-deep .sf-modal__container {
        min-width: 400px;
        width: 80%;
        height: 80%;
      }

      ::v-deep .sf-modal__content {
        padding: 0;
        position: relative;
        height: 100%;
      }
    }

    ::v-deep .sf-modal__container {
      z-index: var(--top-modal-container-z-index);
    }

    ::v-deep .sf-modal__overlay {
      z-index: var(--top-modal-overlay-z-index);
    }
  }

  .sw-quickview-content {
    min-height: 100%;
    display: flex;
    flex-direction: column;
    position: relative;
    height: 100%;
    padding: var(--spacer-xl) var(--spacer-base);
  }

  .sw-quickview-close {
    position: absolute;
    right: 20px;
    top: 10px;
    width: 20px;
    height: 20px;
    z-index: var(--helper-lay-over-sibling-z-index);

    ::v-deep span {
      width: 20px;
      height: 20px;
    }
  }

</style>
